﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Windows.DataPresenter;
using System.Windows;
using System.Collections;
using Infragistics.Windows.DataPresenter.Events;
using System.Windows.Data;
using System.ComponentModel;

namespace MultiSelectListBindingProblem
{
    public class MyDataGrid : XamDataGrid
    {
        public static  DependencyProperty NewXDGSelectedItemsProperty = DependencyProperty.Register("NewXDGSelectedItems", typeof(IEnumerable), typeof(MyDataGrid));

       
        public IEnumerable NewXDGSelectedItems
        {
            get { return (IEnumerable)GetValue(NewXDGSelectedItemsProperty); }
            set { SetValue(NewXDGSelectedItemsProperty, value); } 
        }

        private  void NewXDGSelectedItemsPropertyChanged(DependencyObject sender, DependencyPropertyChangedEventArgs args)
        {
            this.SelectedItemsChanged -= new EventHandler<SelectedItemsChangedEventArgs>(MyDataGrid_SelectedItemsChanged);
            this.ActiveRecord = null;
            if (!this.IsMouseOver)
            {
                this.SelectedItems.Records.Clear();
            }
            
            foreach (var item in args.NewValue as IEnumerable)
            {

                this.SelectedItems.Records.Add(this.GetRecordFromDataItem(item, false));
            }
            this.SelectedItemsChanged += new EventHandler<SelectedItemsChangedEventArgs>(MyDataGrid_SelectedItemsChanged);
        }

        public MyDataGrid() :base()
        {
            this.SelectedItemsChanged += new EventHandler<SelectedItemsChangedEventArgs>(MyDataGrid_SelectedItemsChanged);
            NewXDGSelectedItemsProperty.OverrideMetadata(typeof(MyDataGrid), new FrameworkPropertyMetadata(NewXDGSelectedItemsPropertyChanged));

        }

       
        void MyDataGrid_SelectedItemsChanged(object sender, SelectedItemsChangedEventArgs e)
        {
            List<object> selectedItems = new List<object>();

            foreach (object selectedItem in base.SelectedItems)
            {
                if (selectedItem is Cell)
                    selectedItems.Add(((selectedItem as Cell).Record as DataRecord).DataItem);

                else if (selectedItem is DataRecord)
                    selectedItems.Add((selectedItem as DataRecord).DataItem);
            }

            NewXDGSelectedItems = selectedItems as IEnumerable;
        }
 
      
    }
}
